﻿using System;
using System.ComponentModel;
using DevExpress.ExpressApp.DC;
using DevExpress.Persistent.Base;
using DevExpress.Persistent.Validation;
using DevExpress.Xpo;

namespace K12MIS.Module.BusinessObjects
{
    [DefaultClassOptions]
    [DefaultProperty("SchoolYear")]
    public class SchoolYr : CustomBaseObject
    {
        public SchoolYr() : base()
        {
            // This constructor is used when an object is loaded from a persistent storage.
            // Do not place any code here.
        }

        public SchoolYr(Session session) : base(session)
        {
            // This constructor is used when an object is loaded from a persistent storage.
            // Do not place any code here.
        }

        public override void AfterConstruction()
        {
            base.AfterConstruction();
            // Place here your initialization code.
        }

        decimal schoolYrFee;
        string schoolYear;
        [XafDisplayName("School Year"), ToolTip("Enter the Current School Year")]
        [Index(0), VisibleInListView(true), VisibleInDetailView(true)]
        [RuleRequiredField(DefaultContexts.Save)]

        [Size(9)]
        public string SchoolYear
        {
            get => schoolYear;
            set => SetPropertyValue(nameof(SchoolYear), ref schoolYear, value);
        }

        [Association("SchoolYr-GradeSections")]
        public XPCollection<GradeSection> GradeSections
        {
            get
            {
                return GetCollection<GradeSection>(nameof(GradeSections));
            }
        }

    }

}